/* now from C and heading to one code base albeit kludgy right now */

# include "a7105.h"

unsigned char recdState, recdType;
unsigned char retries;

// packet types for discrimination...
# define REG	0x96
# define ACK	0xb9

# define rLED	2	/* local lamp/switch (BW!) */
# define gLED	3
# define bLED	4

# define RLED	5	/* remote lamp */
# define GLED	6
# define BLED	7

# define GOOD	A1
# define BAD	A2
# define BW		A0	/* touch cycle - why BW mode only? */

# define TOUCH	A3	// a non-toggle touch switch is hanged here

# define NBW	4	// new cycle green yellow red blue (green) 
const unsigned char bwMap[NBW] = {2, 6, 4, 1};
unsigned char bwButton, bwCycle;
void checkBW(void);				/* watch button increment bwCycle */

unsigned char ledState;
unsigned char mySwitches;

unsigned char BWMODE, BLINKMODE;

void lightFSM(void);
void blinkLEDs(void);
unsigned touchTimer, lastTouch;
/* the lightTimer feature is largely overridden by use of 255 == FOREVER */
unsigned char lightTimer;

# define DIM 0
# define BRIGHT 1

unsigned int lamp;
unsigned long loops;

unsigned char recFlag;		// have "we" asked for a packet?
unsigned char needAck;

void fsmFSM(void);
unsigned int printFlag;
unsigned long fsmTimer;

// unsigned char kludgeFlag;	// FIGURE THIS KLUDGE OUT

uint8_t startval, command;
int iCnt;

char myMessage[8];
char ackMessage[8];

void setup() {
	BWMODE = 0;
	BLINKMODE = 1;
	verbose = true;
	iCnt = 0;
		retries = 0;
	/* likewise */	

if (BWMODE) {
	pinMode(rLED, OUTPUT);	/* bw lamps are outputs now negative logic */
	pinMode(gLED, OUTPUT);
	pinMode(bLED, OUTPUT);
}
else {
	pinMode(rLED, INPUT_PULLUP);	/* no _PULLUP in final circuit needed */
	pinMode(gLED, INPUT_PULLUP);
	pinMode(bLED, INPUT_PULLUP);
}
	pinMode(RLED, OUTPUT);
	pinMode(GLED, OUTPUT);
	pinMode(BLED, OUTPUT);

	pinMode(GOOD, OUTPUT); digitalWrite(GOOD, 1);
	pinMode(BAD, OUTPUT); digitalWrite(BAD, 0);
	pinMode(TOUCH, INPUT_PULLUP);
	pinMode(BW, INPUT_PULLUP);

	lastTouch = digitalRead(TOUCH);

	lightTimer = 255;			 /* (140) 7 seconds Bob! NO! forever...*/

	Serial.begin(115200);
	Serial.flush();
	Serial.println("Initialising...");

	// SPI initialisation and mode configuration
	A7105_Setup();

	initialize();

	recFlag = 0;
	needAck = 0;
	k13 = 0x40;
	Serial.println("Initialisation Complete");
	
	fsmTimer = millis();
	printFlag = 7;
	setLEDs(1);
	listeni();
}

unsigned char valid;

void loop() {

	fsmFSM();
	
	if (!printFlag) {
		printFlag = 1000;			 /* evefry x seconds update */
		Serial.print("top o' the loop ");
		Serial.println(millis());
	}

	 if (recFlag && (!(A7105_ReadReg(A7105_00_MODE) & 0x01))) {
		 recFlag = 0;	// hmmm. not for long, but I did not do this.

		 A7105_ReadData(receivedpacket, 16);
		 printpacket(receivedpacket);

		for (; ; ) {
			valid = 0;
			if (receivedpacket[0] != 0xa5) break;
			if (receivedpacket[3] != 0x77) break;
			if (receivedpacket[4] != 0x1e) break;

			valid = 1;
			recdState = receivedpacket[1];
			recdType = receivedpacket[2];

			if (recdType == ACK) {
				setLEDs(2);							/* green? */
				delay(70);
				Serial.println("Caught an ACK");	/* verify & publish */
				needAck = 0;						/* kill the apetite for ACK */
			}
			else {	  /* dumb. assume packet is just coming in out of the blue */
				setLEDs(1);							/* red */
				delay(70);
				kickIt(ACK);
				Serial.println(" ACK receipt kick");
			}
			break;
		}
		if (valid)	  // always...
			setLEDs(recdState);
		else Serial.println("	 not of our making!");		   

		listeni(); // and always go back to listening...
	}	
	iCnt++;
}

void listeni()
{
	A7105_WriteReg(A7105_0F_CHANNEL, 0x50);
	A7105_Strobe(A7105_RX);
	recFlag = 1;	// we want a packet
}

void kickIt(unsigned char xType)
{
	mySwitches = getSwitches();

	A7105_WriteReg(A7105_0F_CHANNEL, 0x50);
	if (A7105_oneShoutRAM(mySwitches, xType))
		Serial.println("shout not gappy!");
}

void lightFSM()
{
	getSwitches();
	if ((lightTimer != 255) && lightTimer && !--lightTimer)
		setLEDs(0);		   /* this is actually OK *//* I think. */
}

void touchFSM()
{
	unsigned char thisTouch;

	thisTouch = digitalRead(TOUCH);
	if (thisTouch != lastTouch) {
		if (lightTimer) doBW();
		else {
			lightTimer = 255;
			setLEDs(3);
			Serial.println(" lights up kick");
			kickIt(REG); listeni(); needAck = 100;
		}
		lightTimer = 255;	/* light them up or refresh */
	}
	lastTouch = thisTouch;	/* watch for edges */
}

unsigned char tween[4] = {3, 5, 7, 11};
void fsmFSM()
{
	static char pulse = 0;
	unsigned char nowSwitches;

	if ((millis() - fsmTimer) < 50) return;
	fsmTimer = millis();
	if (printFlag) --printFlag;
	
	/* 20 Hz now */
   
        //...blinkFSM written right here:

        if (BLINKMODE) blinkLEDs();

	if (needAck && !--needAck && retries) {
		/* redo infinitely until success! */
		retries--;
		Serial.println(" NAK kick");
		kickIt(REG); listeni(); needAck = tween[iCnt & 0x3];
	}

	touchFSM();
	lightFSM(); 

	if (BWMODE) checkBW();	// handle or ignore A0 input */

	nowSwitches = getSwitches();
	if (nowSwitches != mySwitches) {
		setLEDs(0); delay(70); setLEDs(3);
		kickIt(REG); listeni();
		needAck = 70; retries = 7;		// not infinite at all */ 
		Serial.println(" delta kick");
	}
}

void doBW(void) {
	if (++bwCycle == NBW) bwCycle = 0;
	getSwitches();		/* just update our lamps */
	lightTimer = 255;	/* 7 seconds Bob! */
}

void checkBW()
{
	unsigned char buttonNow;
	
	buttonNow = digitalRead(BW);
	if (!buttonNow && bwButton) {
			doBW();
	}
	bwButton = buttonNow;
}

unsigned char getSwitches()
{
	unsigned char rx, gx, bx, xx;

	if (BWMODE) { 
/* this is now simply the uncritical report of bw/bwCycle */
/* oh it sets the lamps also and is only way to do */
		xx = bwMap[bwCycle];

		if (lightTimer) {
			digitalWrite(rLED, !(xx & 0x4));
			digitalWrite(gLED, !(xx & 0x2));
			digitalWrite(bLED, !(xx & 0x1));  
		}
		else {	  /* lightState == DIM */
			digitalWrite(rLED, 1);
			digitalWrite(gLED, 1);
			digitalWrite(bLED, 1);
		}
	}
	else {
	/* in RAM HW, lamps are directly reading the switches */
		rx = digitalRead(rLED);
		gx = digitalRead(gLED);
		bx = digitalRead(bLED);

		xx = (rx ? 0 : 4) | (gx ? 0 : 2) | (bx ? 0 : 1);
	}
	return (xx);
}

// shadow register for lamps to facilitate blinking them
unsigned char xxLamp;

void setLEDs(unsigned char xx)
{
        xxLamp = xx;
	if (lightTimer || !BWMODE) {
		digitalWrite(RLED, !(xx & 0x4));
		digitalWrite(GLED, !(xx & 0x2));
		digitalWrite(BLED, !(xx & 0x1));
	}
	else {
		digitalWrite(RLED, 1);
		digitalWrite(GLED, 1);
		digitalWrite(BLED, 1);
	}
}

// code to blink selecting blue, cyan and yellow
//                               _, b, g, c, r, m, y, w
const unsigned char blinks[8] = {0, 1, 0, 1, 0, 0, 1, 1};
void blinkLEDs()
{
    static unsigned char phase = 10;
    static unsigned char onOff = 1;    /* on! */

// very poor man's scheduler. kill this machine by setting phase to 0!
    if (!phase || --phase) return;
    phase = 10;

    if (!blinks[xxLamp]) {
        setLEDs(xxLamp);    /* prove I don't need this? */
        return;
    }

    if (onOff) {
        onOff = 0;
	digitalWrite(RLED, 1);
	digitalWrite(GLED, 1);
	digitalWrite(BLED, 1);
    }
    else {
        onOff = 1;
        setLEDs(xxLamp);            /* ha! whatever they were */
    }
}


